{=======================================================================================================================

   " ".

       .

========================================================================================================================

  :

  08.03.2015 [+]   .
             [*]  .
  26.02.2015 [+]    .
             [+] taData: TADODataSet.
  22.02.2015 [-] TPropStorageEh.
  19.02.2015 [*] .
  08.03.2012 [*]   .
  26.02.2012 [+]  .
             [+]   .
  12.02.2012 [*] .
  09.02.2012 [!]    Delphi XE2.
  31.03.2011 [*]     .
  30.03.2011 [*]   96 PixelsPerInch.
  04.08.2009 [+]   .
  10.11.2006 [*]   XP.
  25.06.2002 [+]   CreateParams.
  19.11.2001 [*]   .
  15.11.2001 [+]  .
             [*]  .
  08.11.2001 [*]    .
             [-]  TAB.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgBaseEdit.pas,v 1.2 2015/03/08 09:03:46 tsk Exp $
=======================================================================================================================}
unit dgBaseEdit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Buttons, DB, Data.Win.ADODB;

type
  TBaseEditDG = class(TForm)
    btCancel: TBitBtn;
    btSave: TBitBtn;
    dsData: TDataSource;
    taData: TADODataSet;
    procedure dsDataDataChange(Sender: TObject; Field: TField);
    procedure btSaveClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
  private
    FVisual: Boolean;
    procedure SetVisual(const Value: Boolean);   { Private declarations }
  public    { Public declarations }
    property Visual: Boolean read FVisual write SetVisual;
  end;

implementation

{$R *.DFM}
//======================================================================================================================
{ TBASEEditDG }
//======================================================================================================================
procedure TBaseEditDG.dsDataDataChange(Sender: TObject; Field: TField);
begin
  btSave.Enabled := ( dsData.State in [ dsEdit, dsInsert ] );
end;
//======================================================================================================================
procedure TBaseEditDG.SetVisual(const Value: Boolean);
begin
  if FVisual <> Value then begin
    if FVisual then begin
//      Screen.Cursor := crDefault;
      taData.EnableControls;
    end else begin
      taData.DisableControls;
//      Screen.Cursor := crHourGlass;
    end;
  end;
end;
//======================================================================================================================
procedure TBaseEditDG.btSaveClick(Sender: TObject);
  var i: Integer;
begin
  //  :
  for i := 0 to taData.FieldCount - 1 do
    if ( taData.Fields[i] is TStringField ) and ( taData.Fields[i].Value = EmptyStr ) then taData.Fields[i].Clear;
  try
    taData.Post;
  except on E: Exception do begin
      taData.Cancel;
      ModalResult := mrCancel;
      Application.ShowException( E );
    end;
  end;
end;
//======================================================================================================================
procedure TBaseEditDG.btCancelClick(Sender: TObject);
begin
  taData.Cancel;
end;
//======================================================================================================================
end.

