/*=====================================================================================================================

   " ".

     . .

=======================================================================================================================

  :

  11.03.2015 [*] ChainComponent:   .
  04.03.2015 [*] ChainModel:    .
  24.02.2015 [+] ChainWorkplace:  .
             [+] ChainDevice: .
  22.02.2015 [+] ChainKind: .
  20.02.2015 [+] ChainModel: .
             [+] ChainComponent:  ( ).
             [+]  .
  09.10.1997 [!]  .

=======================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scChain.sql,v 1.2 2015/03/11 13:34:27 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure 'ChainComponent'
EXECUTE CheckDropProcedure 'ChainModel'
EXECUTE CheckDropProcedure 'ChainKind'
EXECUTE CheckDropProcedure 'ChainDevice'
EXECUTE CheckDropProcedure 'ChainWorkplace'
--
GO
--=====================================================================================================================
CREATE PROCEDURE ChainComponent @CM INT
AS
  SELECT CompleteSet.IdComponent                  AS IDComponent,
         CompleteSet.CmplIdDevice                 AS IDDevice,
         Model.IdModel                            AS IDModel, 
         Kind.IdKind                              AS IDKind, 
         Kind.KindType                            AS IDType, 
         ISNULL([Document].IdDocument, -1)        AS IDDocument, 
         ISNULL(CompleteSet.DocumentPosition, -1) AS NBPosition, 
         ISNULL(Shipper.IdClient, -1)             AS IDShipper,
         ISNULL(ShipperTM.ID, -1)                 AS IDShipperTM, 
         Producer.IdClient                        AS IDProducer, 
         ISNULL(ProducerTM.ID, -1)                AS IDProducerTM
    FROM Client AS Producer 
      INNER JOIN CompleteSet 
      INNER JOIN Model ON CompleteSet.CmplIdModel = Model.IdModel 
      INNER JOIN Kind ON Model.ModlKind = Kind.IdKind ON Producer.IdClient = Model.ModlIdProducer 
      LEFT OUTER JOIN [Document] 
      INNER JOIN Client AS Shipper ON [Document].DocClient = Shipper.IdClient ON CompleteSet.DocumentId = [Document].IdDocument 
      LEFT OUTER JOIN Trademark AS ProducerTM ON Producer.Trademark = ProducerTM.ID 
      LEFT OUTER JOIN Trademark AS ShipperTM ON Shipper.Trademark = ShipperTM.ID
    WHERE (CompleteSet.IdComponent = @CM)
--
GO
--=====================================================================================================================
CREATE PROCEDURE ChainModel @MD INT
AS
  IF NOT EXISTS ( SELECT IdModel FROM Model WHERE (IdModel = @MD))
  SELECT TOP (1) CAST( -1 AS INT) AS IDModel,
         IdKind                   AS IDKind, 
         KindType                 AS IDType,
         CAST( -1 AS INT)         AS IDProducer, 
         CAST( -1 AS INT)         AS IDProducerTM
    FROM Kind
    WHERE (KindType = 'H')
    ORDER BY NEWID();
  ELSE
  SELECT Model.IdModel            AS IDModel, 
         Kind.IdKind              AS IDKind, 
         Kind.KindType            AS IDType, 
         Client.IdClient          AS IDProducer, 
         ISNULL(Trademark.ID,-1)  AS IDProducerTM
    FROM Model 
      INNER JOIN Kind ON Model.ModlKind = Kind.IdKind 
      INNER JOIN Client ON Model.ModlIdProducer = Client.IdClient 
      LEFT OUTER JOIN Trademark ON Client.Trademark = Trademark.ID
    WHERE (Model.IdModel = @MD)
--
GO
--=====================================================================================================================
CREATE PROCEDURE ChainKind @KD INT
AS
  SELECT IdKind   AS IDKind, 
         KindType AS IDType
    FROM Kind
    WHERE (IdKind = @KD)
--
GO
--=====================================================================================================================
CREATE PROCEDURE ChainDevice @DV INT
AS
  SELECT DeviceUnit.IdDevice      AS IDDevice, 
         DeviceUnit.DevcIdKind    AS IDKind, 
         Workplace.IdWorkplace    AS IDWorkplace, 
         Department.IdDepartment  AS IDDepartment
    FROM DeviceUnit 
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
    WHERE (DeviceUnit.IdDevice = @DV)
--
GO
--=====================================================================================================================
CREATE PROCEDURE ChainWorkplace @WP INT
AS
  SELECT Workplace.IdWorkplace    AS IDWorkplace, 
         Department.IdDepartment  AS IDDepartment
    FROM Workplace 
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
    WHERE (Workplace.IdWorkplace = @WP)
--
GO
--=====================================================================================================================
-- 
---- Component:
--  1143 = USR Sporster: 33600, Int (ISA), Fax  9911710059345160
-- 10391 = Core i5-3570K  2R220384A2496
---- Model:
-- 278 = USR Sporster: 33600, Int (ISA)
---- Kind:
-- 25 = 
---- Device:
-- 575 = ,  U575
---- Workplace:
-- 155 = 
--
EXECUTE ChainComponent 1143
--EXECUTE ChainModel -1
--EXECUTE ChainKind 25
--EXECUTE ChainDevice 575
--EXECUTE ChainWorkplace 155