/*=====================================================================================================================

   " ".

      . .

=======================================================================================================================

  :

  03.03.2015 [*] GridCompleteSet:        .
  20.02.2015 [*] GridCompleteSet:   .
  24.03.2012 [*] ViewWorkplacePowerName:    .
  20.03.2012 [*] ViewWorkplacePowerName:      LoadNodeWorkPlace.
  24.02.2012 [*] .
  22.02.2012 [+] ViewWorkplacePowerName:     .
  15.12.2010 [*] GridCompleteSet:  .
  14.02.2007 [*] GridCompleteSet:   .
             [*] GridCompleteSet:    .
  05.02.2007 [*] GridCompleteSet:   .
  26.12.2006 [*]      .
  14.12.2006 [+]  .
  09.10.1997 [!]  .

=======================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scList.sql,v 1.8 2015/03/03 13:41:44 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropView		    'ViewWorkplacePowerName'
EXECUTE CheckDropProcedure  'GridCompleteSet'
--
GO
--=====================================================================================================================
CREATE VIEW ViewWorkplacePowerName
AS
  SELECT Workplace.IdWorkplace  AS ID,
         WrkpIdDepartment       AS Higher,
         WrkpOrder              AS [Order],
         Workplace.WrkpName     AS Name, 
         Workplace.WrkpName + ISNULL('  ' + Workplace.Synonym, '') + ISNULL('  ' + Workplace.Phone, '') 
                                        + ISNULL('  ' + [User].Login, '') + ISNULL('  ' + [User].Name, '') AS NameFind, 
         Workplace.WrkpName + '/' + Department.DprtName AS NameDepartment,
         Workplace.WrkpName + ISNULL(', ' + [User].Name, '') AS NameUser,
         Workplace.WrkpName + ISNULL(', ' + [User].Name, '') + '/' + Department.DprtName AS NameUserDepartment
    FROM Workplace 
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
      LEFT OUTER JOIN [User] ON Workplace.[User] = [User].ID
--
GO
--=====================================================================================================================
CREATE PROCEDURE GridCompleteSet @DV INT, @KD CHAR(1) = 'H'
AS
  SELECT CompleteSet.IdComponent    AS ID, 
         Kind.ShortName             AS Kind, 
         Model.DisplayName          AS Model, 
         CompleteSet.DisplayNumber  AS Number,
         Kind.KindType              AS [Type],
         Kind.IdKind                AS IDKind,
         Model.IdModel              AS IDModel,                       
         DocumentId                 AS [Document],
         DocumentPosition
  FROM CompleteSet
    INNER JOIN Model ON CompleteSet.CmplIdModel = Model.IdModel 
    INNER JOIN Kind ON Model.ModlKind = Kind.IdKind
  WHERE (CompleteSet.CmplIdDevice = @DV) AND (Kind.KindType = @KD)
  ORDER BY Kind.KindOrder, Model.ModlWeight
--
GO
--=====================================================================================================================
-- 
--EXECUTE GridCompleteSet 12, 'H'
SELECT * FROM ViewWorkplacePowerName
