{=======================================================================================================================

   "".

     , , .

========================================================================================================================

  :

  05.06.2015 [+]  : .
  04.03.2015 [+]   -.
  23.02.2015 [*]  DBNavigator  .
  20.02.2015 [*]   .
  08.06.2013 [*]  :    .
             [*] .
  30.12.2012 [*]    .
  08.03.2012 [*]     .
             [+]       dmComming.SetCommingValue.
             [*] 
             [*]  .
  24.02.2012 [*] .
  09.02.2012 [!]    Delphi XE2.
  31.03.2011 [*]   Windows 7.
  12.02.2007 [*]     DBLookupCombobox.
  02.07.2007 [-]  uses    RXLib.
  04.04.2007 [*]   .
  03.04.2007 [+]    .
             [*]  .
  13.02.2007 [-]    .
             [*]   -.
  05.02.2007 [*]      XP.
  20.11.2001 [*]    .
             [-]  .
             [-]  TAB.
             [*]   TBASEListDG.
  13.11.2001 [*]     RecordExchangeMoving.
             [+]  -
             [-]  .
             [*]   , .
  12.11.2001 [*]    .
             [*]     RecordExchangeMoving.
             [*]  .
  09.11.2001 [+]  Comming.
             [*]    .
             [*]   MS SQL Server 2000  ODBC   TDataSet.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgModelList.pas,v 1.14 2015/06/05 05:04:44 tsk Exp $
=======================================================================================================================}
unit dgModelList;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DB, ADODB, StdCtrls, Mask, DBCtrls,
      Buttons, Grids, DBGridEh, ExtCtrls, DBGrids, DBCtrlsEh, DBLookupEh, DBGridEhGrouping, GridsEh, ToolCtrlsEh,
      DBGridEhToolCtrls, DBAxisGridsEh, DynVarsEh,
      // Comming:
      CommingOther, CommingADO, CommingDialog,
      // ComputerWare:
      dgBaseList, dmLookUpData, dgModelEdit, dgKindList, dmCommingData;

type
  TModelSort = ( msName = 0, msWeight = 1 );

  TModelListDG = class( TBASEListDG )
    btUp: TSpeedButton;
    btDown: TSpeedButton;
    taModel: TADODataSet;
    taModelIdModel: TAutoIncField;
    taModelModlWeight: TIntegerField;
    taModelModlName: TStringField;
    taModelModlParametersValue: TStringField;
    taModelModlNote: TStringField;
    taModelModlKind: TSmallintField;
    taModelModlIdProducer: TIntegerField;
    lcKind: TDBLookupComboboxEh;
    btKind: TSpeedButton;
    spMove: TADOStoredProc;
    taModelDisplayParameters: TStringField;
    procedure sbKindClick(Sender: TObject);
    procedure lcKindChange(Sender: TObject);
    procedure btUpClick(Sender: TObject);
    procedure btDownClick(Sender: TObject);
    procedure grKindTitleClick(Column: TColumnEh);
    procedure btBackClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btInsertClick(Sender: TObject);
    procedure btEditClick(Sender: TObject);
    procedure btRefreshClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
  private   { Private declarations }
    FSort: TModelSort;
    procedure   SetSort(const Value: TModelSort);
    procedure   ModelCursor( ID: Integer );
    procedure   RefreshKind( ID: Integer );
    procedure   RefreshModel( ID: Integer );
    property    ModelSort: TModelSort read FSort write SetSort;
  public    { Public declarations }
    function    Run( Model: Integer; Back: TField = nil; Kind: Integer = CURRENT_RECORD ): Boolean;
  end;

var  ModelListDG: TModelListDG;

implementation

{$R *.DFM}

uses dmChainData;
//======================================================================================================================
{ TModelListDG }
//======================================================================================================================
function TModelListDG.Run( Model: Integer; Back: TField; Kind: Integer ): Boolean;
begin
  if ModelListDG = nil then Application.CreateForm( TModelListDG, ModelListDG );
  with ModelListDG do begin
    if Model = SAVE_RECORD then Model := Tag;
    if Kind <> CURRENT_RECORD then begin
      RefreshKind( Kind );
      ModelCursor( Model );
    end else begin
      RefreshModel( Model );
    end;
    SetSort( msWeight );
    Field := Back;
    Result := ( ShowModal = mrOk );
  end;
end;
//======================================================================================================================
procedure TModelListDG.FormCreate(Sender: TObject);
begin
  inherited;
  lcKind.ListSource := dmLookUp.dsKind;
  ModelSort := msWeight;
end;
//======================================================================================================================
procedure TModelListDG.RefreshKind( ID: Integer );
begin
  dmChain.Kind := ID;
  dmLookUp.SetKindType( dmChain.KindType );
  lcKind.KeyValue := ID;
end;
//======================================================================================================================
procedure TModelListDG.RefreshModel(ID: Integer);
begin
  dmChain.Model := ID;
  dmLookUp.SetKindType( dmChain.KindType );
  lcKind.KeyValue := dmChain.Kind;
  ModelCursor( ID );
end;
//======================================================================================================================
procedure TModelListDG.ModelCursor( ID: Integer );
begin
  Screen.Cursor := crHourGlass;
  if ( ID < 0 ) and ( taModel.Active ) then ID := taModelIdModel.Value;
  RequeryParameters( taModel, [ lcKind.KeyValue ]);
  taModel.Locate( 'IdModel', ID, [] );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TModelListDG.lcKindChange(Sender: TObject);
begin
  ModelCursor( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TModelListDG.sbKindClick(Sender: TObject);
begin
  KindListDG.Run( dmLookUp.taKindID.Value, dmLookUp.taKindID, dmLookUp.taKindKindType.AsString );
end;
//======================================================================================================================
procedure TModelListDG.btInsertClick(Sender: TObject);
begin
//  inherited;
  if ModelEditDG.Run( INSERT_DATA, lcKind.KeyValue ) then RefreshModel( ModelEditDG.taDataIdModel.Value);
end;
//======================================================================================================================
procedure TModelListDG.btEditClick(Sender: TObject);
begin
//  inherited;
  if ModelEditDG.Run( taModelIdModel.Value, lcKind.KeyValue ) then RefreshModel( ModelEditDG.taDataIdModel.Value);
end;
//======================================================================================================================
procedure TModelListDG.btDeleteClick(Sender: TObject);
begin
//  inherited;
  if ShowAskDelete( taModelModlName.AsString ) then begin
    taModel.Delete;
    ModelCursor( CURRENT_RECORD );
  end;
end;
//======================================================================================================================
procedure TModelListDG.btRefreshClick(Sender: TObject);
begin
//  inherited;
  ModelCursor( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TModelListDG.btUpClick(Sender: TObject);
begin
  spMove.Parameters[1].Value := taModelIdModel.Value;
  spMove.Parameters[2].Value := -1;
  spMove.ExecProc;
  ModelCursor( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TModelListDG.btDownClick(Sender: TObject);
begin
  spMove.Parameters[1].Value := taModelIdModel.Value;
  spMove.Parameters[2].Value := 1;
  spMove.ExecProc;
  ModelCursor( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TModelListDG.grKindTitleClick( Column: TColumnEh );
begin
  inherited;
  if Column.Title.SortMarker = smNoneEh then begin
    ModelSort := TModelSort( Column.Index );
    ModelCursor( CURRENT_RECORD );
  end;
end;
//======================================================================================================================
procedure TModelListDG.SetSort( const Value: TModelSort );
begin
  if FSort <> Value then begin
    FSort := Value;
    case FSort of
      msName:   taModel.IndexFieldNames := 'ModlName';
      msWeight: taModel.IndexFieldNames := 'ModlWeight';
    end;
    with grList do begin
      Columns[0].Title.SortMarker := iif( FSort = msName,   smUpEh,   smNoneEh );
      Columns[1].Title.SortMarker := iif( FSort = msWeight, smDownEh, smNoneEh );
    end;
    btUp.Enabled    := ( FSort = msWeight );
    btDown.Enabled  := ( FSort = msWeight );
  end;
end;
//======================================================================================================================
procedure TModelListDG.btBackClick(Sender: TObject);
begin
  inherited;
  SetBackValue( taModelIdModel.Value );
end;
//======================================================================================================================
end.
