/*=====================================================================================================================

   " ".

    .

=======================================================================================================================

  :

  28.06.2012 [*] ReportPrevention:  ,    .
  19.06.2014 [*] ReportPrevention:      .
  18.06.2014 [*] ReportPrevention:     .
  17.06.2014 [*] ReportPrevention:       .
  13.06.2014 [+] ReportPrevention: .
  15.04.2014 [-]       .
  17.03.2012 [+] ReportMailBox:    .
  14.03.2012 [*] ReportLastMove:  .
  05.03.2012 [+] ReportUser:  .
  26.02.2012 [+] ExcelNodeList:    .
  25.02.2012 [+] ReportComputer:  .
  17.02.2012 [+] ReportLastMove:  .
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972014 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scCommingReport.sql,v 1.1 2015/03/08 05:02:42 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure  'ReportLastMove'
EXECUTE CheckDropProcedure  'ReportComputer'
EXECUTE CheckDropProcedure  'ReportPrevention'
--
GO
--=====================================================================================================================
CREATE PROCEDURE ReportLastMove
AS
  SELECT CONVERT(VARCHAR, Moving, 104) AS Moving,
         Displacement.Doer, 
         Model.ModlName AS ModelName, 
         Model.ModlParametersValue AS ModelParameters, 
         CompleteSet.DisplayNumber, 
         Displacement.Device, 
         Displacement.Workplace, 
         Displacement.Department
    FROM Displacement 
      INNER JOIN CompleteSet ON Displacement.Component = CompleteSet.IdComponent 
      INNER JOIN Model ON CompleteSet.CmplIdModel = Model.IdModel
    ORDER BY Displacement.Moving DESC
--
GO
--=====================================================================================================================
CREATE PROCEDURE ReportComputer 
AS
  SELECT Department.DprtName, 
         Workplace.WrkpName, 
         DeviceUnit.DevcName, 
         DeviceUnit.DevcDescription,
         DeviceUnit.DevcNumber, 
         Kind.KindOrder, 
         Kind.KindName
  FROM DeviceUnit 
    INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
    INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment 
    INNER JOIN Kind ON DeviceUnit.DevcIdKind = Kind.IdKind
  WHERE (DeviceUnit.DevcPrinting = 1)
  ORDER BY Department.DprtName, Workplace.WrkpName, Kind.KindOrder DESC
--
GO
--=====================================================================================================================
CREATE PROCEDURE ReportPrevention
AS
  DECLARE @DM DATE
  SELECT  @DM = MIN(Prevention) FROM DeviceUnit HAVING (NOT (MIN(Prevention) IS NULL))
  --
  SELECT 5 AS S1, '20010101' AS S2,
         Department.DprtName 
           + '; ' + Workplace.WrkpName + ISNULL(' (' + Workplace.Phone + ')', '') 
           + ISNULL(', ' + [User].Login, '') + ISNULL(': ' + [User].Name, '') AS [ ], 
         DeviceUnit.DisplayNumber + ISNULL(' (' + DeviceUnit.Domain + ')', '') AS , 
         CAST('' AS Varchar(25)) AS 
    FROM DeviceUnit 
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
      LEFT OUTER JOIN [User] ON Workplace.[User] = [User].ID
    WHERE (DeviceUnit.DevcIdKind = 118) AND (DeviceUnit.PreventionExpress = 1) AND ([OnLine] = 1) 
          AND (PreventionNeed = 1)
  --
  UNION
  --
  SELECT 4, '20010101',
         Department.DprtName 
           + '; ' + Workplace.WrkpName + ISNULL(' (' + Workplace.Phone + ')', '') 
           + ISNULL(', ' + [User].Login, '') + ISNULL(': ' + [User].Name, ''), 
         DeviceUnit.DisplayNumber + ISNULL(' (' + DeviceUnit.Domain + ')', ''), 
         '  '
    FROM DeviceUnit 
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
      LEFT OUTER JOIN [User] ON Workplace.[User] = [User].ID
    WHERE (DeviceUnit.DevcIdKind = 118) AND (DeviceUnit.PreventionExpress = 1) AND ([OnLine] = 0) 
          AND (PreventionNeed = 1)
  --
  UNION
  --
  SELECT 3, CONVERT(VARCHAR, DATEADD(d, - 2 * ROW_NUMBER() OVER (ORDER BY NEWID()), @DM ), 112), 
         Department.DprtName 
           + '; ' + Workplace.WrkpName + ISNULL(' (' + Workplace.Phone + ')', '') 
           + ISNULL(', ' + [User].Login, '') + ISNULL(': ' + [User].Name, ''), 
         DeviceUnit.DisplayNumber + ISNULL(' (' + DeviceUnit.Domain + ')', ''), 
         NULL
    FROM DeviceUnit
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
      LEFT OUTER JOIN [User] ON Workplace.[User] = [User].ID
    WHERE (DeviceUnit.DevcIdKind = 118) AND (DeviceUnit.Prevention IS NULL) AND (ISNULL(DeviceUnit.PreventionExpress, 0) < 1) 
          AND (PreventionNeed = 1) AND ([OnLine] = 1)
  --
  UNION
  --
  SELECT 2, CONVERT(VARCHAR, DATEADD(d, - 2 * ROW_NUMBER() OVER (ORDER BY NEWID()), @DM ), 112), 
         Department.DprtName 
           + '; ' + Workplace.WrkpName + ISNULL(' (' + Workplace.Phone + ')', '') 
           + ISNULL(', ' + [User].Login, '') + ISNULL(': ' + [User].Name, ''), 
         DeviceUnit.DisplayNumber + ISNULL(' (' + DeviceUnit.Domain + ')', ''), 
         ' '
    FROM DeviceUnit
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
      LEFT OUTER JOIN [User] ON Workplace.[User] = [User].ID
    WHERE (DeviceUnit.DevcIdKind = 118) AND (DeviceUnit.Prevention IS NULL) AND (ISNULL(DeviceUnit.PreventionExpress, 0) < 1) 
          AND (PreventionNeed = 1) AND ([OnLine] = 0)
  --
  UNION
  --
  SELECT 1, CONVERT(VARCHAR, DeviceUnit.Prevention, 112) , 
         Department.DprtName
           + '; ' + Workplace.WrkpName + ISNULL(' (' + Workplace.Phone + ')', '') 
           + ISNULL(', ' + [User].Login, '') + ISNULL(': ' + [User].Name, ''), 
         DeviceUnit.DisplayNumber + ISNULL(' (' + DeviceUnit.Domain + ')', ''), 
         CONVERT(VARCHAR, DeviceUnit.Prevention, 104)
    FROM DeviceUnit
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
      LEFT OUTER JOIN [User] ON Workplace.[User] = [User].ID
    WHERE (DeviceUnit.DevcIdKind = 118) AND (NOT (DeviceUnit.Prevention IS NULL)) 
          AND (PreventionNeed = 1) AND ([OnLine] = 1)
  --
  UNION
  --
  SELECT 0, CONVERT(VARCHAR, DeviceUnit.Prevention, 112) , 
         Department.DprtName
           + '; ' + Workplace.WrkpName + ISNULL(' (' + Workplace.Phone + ')', '') 
           + ISNULL(', ' + [User].Login, '') + ISNULL(': ' + [User].Name, ''), 
         DeviceUnit.DisplayNumber + ISNULL(' (' + DeviceUnit.Domain + ')', ''), 
         ' '
    FROM DeviceUnit
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
      LEFT OUTER JOIN [User] ON Workplace.[User] = [User].ID
    WHERE (DeviceUnit.DevcIdKind = 118) AND (NOT (DeviceUnit.Prevention IS NULL)) 
          AND (PreventionNeed = 1) AND ([OnLine] = 0)
  --
  ORDER BY 1 DESC, 2
--
GO
--=====================================================================================================================
-- 
--
--EXECUTE ReportLastMove
--EXECUTE ReportComputer
EXECUTE ReportPrevention






